//+--------------------------------------------------------------------------+
//|                                                                          |
//|                               PNG spinner                                |
//|                                                                          |
//|                       layered spinner annimation                         |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                            copyright(c) 2014                             |
//|                           www.zapsolution.com                            |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 01-05-2013 (MM-DD-YYYY)            |
//|                        Last revised : 01-13-2013 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

#include <windows.h>
#include <WinBase.h>
#include <Dwmapi.h>

#define TIMER_DELAY   30
#define TIMER_SPINNER -1

// GDIPLUS Flat API
#ifndef _GDIPLUS_H
#define _GDIPLUS_H
struct IDirectDrawSurface7;
typedef signed   short  INT16;
typedef unsigned short  UINT16;
#include <pshpack8.h>   // set structure packing to 8
namespace DllExports {
#include "GdiplusMem.h"
};
#include "GdiplusBase.h"
#include "GdiplusEnums.h"
#include "GdiplusTypes.h"
#include "GdiplusInit.h"
#include "GdiplusPixelFormats.h"
#include "GdiplusColor.h"
#include "GdiplusMetaHeader.h"
#include "GdiplusImaging.h"
#include "GdiplusGpStubs.h"
#include "GdiplusHeaders.h"
#endif // !_GDIPLUS_HPP

struct PROP {
    HWND      hwnd;
    LONG_PTR  img;
    long      framecount;
    long      frametouse;
    HDC       hdc;
    HBITMAP   hbitmap;
    HMODULE   gdiplib;
    LONG_PTR  hgdiplus;
};

PROP gP;

#define long_proc typedef long (__stdcall *zProc)

long Load_GDIPLUS() {
    static long nRet;
    if (nRet == 0) {
        gP.gdiplib = LoadLibrary(L"GDIPLUS");
        if (gP.gdiplib != 0) { nRet = -1; }
    }
    return nRet;
}

long GdiplusStart(OUT LONG_PTR &hGDIplus, GdiplusStartupInput &inputbuf, IN LONG_PTR outputbuf) {
    long nRet = -1; // Error
    if (gP.gdiplib) {
        long_proc(LONG_PTR*, GdiplusStartupInput*, LONG_PTR);
        zProc hPROC = (zProc)GetProcAddress(gP.gdiplib, "GdiplusStartup");
        if (hPROC) {
            nRet = hPROC(&hGDIplus, &inputbuf, outputbuf);
        }
    }
    return nRet;
}

long GdiplusShutdown(IN LONG_PTR hGDIplus) {
    long nRet = -1; // Error
    if (gP.gdiplib) {
        long_proc(LONG_PTR);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdiplusShutdown");
        if (hProc) { nRet = hProc(hGDIplus); }
    }
    return nRet;
}

long GdipLoadImageFromFile(IN WCHAR* szImgName, OUT LONG_PTR &lpImg) {
    long nRet = -1; // Error
    lpImg = 0;
    if (gP.gdiplib) {
        long_proc(WCHAR*, LONG_PTR*);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipLoadImageFromFile");
        if (hProc) {
            nRet = hProc(szImgName, &lpImg);
        }
    }
    return nRet;
}

long GdipDeleteGraphics(IN LONG_PTR graphics) {
    long nRet = -1; // Error
    if (gP.gdiplib) {
        long_proc(LONG_PTR);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipDeleteGraphics");
        if (hProc) { nRet = hProc(graphics); }
    }
    return nRet;
}

long GdipDrawImageRectRectI(IN LONG_PTR graphics, IN LONG_PTR lpImg, IN long dstX, IN long dstY, IN long dstW, IN long dstH, IN long srcX, IN long srcY, IN long srcW, IN long srcH, IN long srcUnit, IN LONG_PTR imageattr, IN LONG_PTR lpCallback, IN LONG_PTR callbackdata) {
    long nRet = -1; // Error
    if (gP.gdiplib) {
        long_proc(LONG_PTR, LONG_PTR, long, long, long, long, long, long, long, long, long, LONG_PTR, LONG_PTR, LONG_PTR);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipDrawImageRectRectI");
        if (hProc) { nRet = hProc(graphics, lpImg, dstX, dstY, dstW, dstH, srcX, srcY, srcW, srcH, srcUnit, imageattr, lpCallback, callbackdata); }
    }
    return nRet;
}

long GdipDisposeImage(IN LONG_PTR lpImg) {
    long nRet = -1; // Error
    if (gP.gdiplib) {
        long_proc(LONG_PTR);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipDisposeImage");
        if (hProc) { nRet = hProc(lpImg); }
    }
    return nRet;
}

long GdipGetImageWidth(IN LONG_PTR lpImg, OUT long &imgW) {
    long nRet = -1; // Error
    imgW = 0;
    if (gP.gdiplib) {
        long_proc(LONG_PTR, long*);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipGetImageWidth");
        if (hProc) { nRet = hProc(lpImg, &imgW); }
    }
    return nRet;
}

long GdipGetImageHeight(IN LONG_PTR lpImg, OUT long &imgH) {
    long nRet = -1; // Error
    imgH = 0;
    if (gP.gdiplib) {
        long_proc(LONG_PTR, long*);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipGetImageHeight");
        if (hProc) { nRet = hProc(lpImg, &imgH); }
    }
    return nRet;
}

long GdipCreateFromHDC(IN HDC hDC, OUT LONG_PTR &graphics) {
    long nRet = -1; // Error
    graphics = 0;
    if (gP.gdiplib) {
        long_proc(HDC, LONG_PTR*);
        zProc hProc = (zProc)GetProcAddress(gP.gdiplib, "GdipCreateFromHDC");
        if (hProc) { nRet = hProc(hDC, &graphics); }
    }
    return nRet;
}

LONG_PTR GdipStart() {
    if (Load_GDIPLUS()) {
        // Load the GDI+ Dll
        GdiplusStartupInput GpInput;
        GpInput.GdiplusVersion = 1;
        LONG_PTR hGDIplus = 0;
        if (GdiplusStart(hGDIplus, GpInput, NULL) == 0) {
            gP.hgdiplus = hGDIplus;
        }
    }
    return gP.hgdiplus;
}

void GdipEnd(IN LONG_PTR hGDIplus) {
    if (hGDIplus) { GdiplusShutdown(hGDIplus); }
}

BOOL FileExist(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = { 0 };
    BOOL bRet = FALSE;
    if (wcslen(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            bRet = TRUE;
        }
    }
    return bRet;
}

HBITMAP CreateDIBSection32(IN HDC hDC, IN long nWidth, IN long nHeight) {
    BITMAPINFO bi = { 0 };
    bi.bmiHeader.biSize = sizeof(bi.bmiHeader);
    bi.bmiHeader.biWidth = nWidth;
    bi.bmiHeader.biHeight = -nHeight; // We want to use top left at coordinates 0,0.
    bi.bmiHeader.biPlanes = 1;
    bi.bmiHeader.biBitCount = 32;     // We use 32-bit (alpha channel).
    bi.bmiHeader.biCompression = BI_RGB;
    return CreateDIBSection(hDC, &bi, DIB_RGB_COLORS, NULL, NULL, NULL);
}

void Animate(IN LPVOID Delay) {
    LONG_PTR graphics = 0;
    RECT r = { 0 };
    SIZEL lpSize = { 0 };
    GetWindowRect(gP.hwnd, &r);
    lpSize.cx = r.right - r.left; lpSize.cy = r.bottom - r.top;
    SetRect(&r, 0, 0, lpSize.cx, lpSize.cy);

    if (gP.img == 0) { return; }

    RECT rw = { 0 };
    BLENDFUNCTION bf = { 0 };
    bf.BlendOp = AC_SRC_OVER;
    bf.BlendFlags = 0;
    bf.AlphaFormat = AC_SRC_ALPHA;
    bf.SourceConstantAlpha = 255;

    POINT lp = { 0 }, ptSrc = { 0 };

DoLoop:
    if (gP.hbitmap == 0) {
        HDC DesktopDC = GetDC(0);
        gP.hdc = CreateCompatibleDC(DesktopDC);
        gP.hbitmap = CreateDIBSection32(gP.hdc, lpSize.cx, lpSize.cy);
        SelectObject(gP.hdc, gP.hbitmap);
        ReleaseDC(0, DesktopDC);
    }
    if (gP.hbitmap) {
        // Create a GDI32 transparent brush, to clear the background of our permanent bitmap.
        HGDIOBJ hBrush = CreateSolidBrush(NULL);
        SelectObject(gP.hdc, hBrush);
        FillRect(gP.hdc, &r, (HBRUSH)hBrush);
        DeleteObject(hBrush);

        if (GdipCreateFromHDC(gP.hdc, graphics) == 0) {
            gP.frametouse += 1; if (gP.frametouse > gP.framecount) { gP.frametouse = 1; }
            if (gP.img) {
                GdipDrawImageRectRectI(graphics, gP.img, 0, 0, lpSize.cx, lpSize.cy, lpSize.cx * gP.frametouse - lpSize.cx, 0, lpSize.cx, lpSize.cy, 2, 0, NULL, NULL);
            }
            GdipDeleteGraphics(graphics);
        }

        GetWindowRect(gP.hwnd, &rw); lp.x = rw.left; lp.y = rw.top;
        UpdateLayeredWindow(gP.hwnd, 0, &lp, &lpSize, gP.hdc, &ptSrc, 0, &bf, ULW_ALPHA);

        Sleep((DWORD)Delay); 
    }

    goto DoLoop; // Nothing faster than a good ASM jump.
}

long StartAnimation(IN long Delay) {
    long nRet = LB_ERR;
    DWORD dwThreadId = 0;
    HANDLE hThread = CreateThread(NULL,        // default security attributes
        0,                                     // use default stack size  
        (LPTHREAD_START_ROUTINE)Animate,       // thread function name
        (LPVOID)Delay,                         // argument to thread function 
        0,                                     // use default creation flags 
        &dwThreadId);                          // returns the thread identifier
    if (hThread) { nRet = 0; Sleep(100); }
    CloseHandle(hThread);
    return nRet;
}

void SpinnerInit(IN HWND hParent, IN HWND hWnd, IN WCHAR* szFileName, IN long nSpeedDelay) {

    if (IsWindow(hParent) == 0) { hParent = GetDesktopWindow(); }

    gP.framecount = 0;
    if (gP.img) { GdipDisposeImage(gP.img); gP.img = 0; }

    if (GdipLoadImageFromFile(szFileName, gP.img) == 0) {
        long w, h;
        RECT r = { 0 }; GetWindowRect(hParent, &r);
        GdipGetImageWidth(gP.img, w);
        GdipGetImageHeight(gP.img, h);
        gP.framecount = w / h;
        MoveWindow(hWnd, r.left + ((r.right - r.left - h) / 2), r.top + ((r.bottom - r.top - h) / 2), h, h, 0);

        // Compute animation speed, based on the number of frames.
        if (nSpeedDelay == 0) {
            if (gP.framecount < 4) {
                nSpeedDelay = 75;
            }
            else if (gP.framecount < 8) {
                nSpeedDelay = 50;
            }
            else if (gP.framecount < 12) {
                nSpeedDelay = 37;
            }
            else {
                nSpeedDelay = TIMER_DELAY;
            }
        }

        gP.hwnd = hWnd; StartAnimation(nSpeedDelay);

    }
}

LRESULT CALLBACK SpinnerProc(IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {
    switch (uMsg) {
    case WM_KEYDOWN:
        if (wParam == VK_ESCAPE) { DestroyWindow(hWnd); }
        break;

    case WM_NCHITTEST:
        return HTCAPTION;

    case WM_DESTROY:
        if (gP.hbitmap) { DeleteObject(gP.hbitmap); }
        if (gP.hdc) { DeleteDC(gP.hdc); }
        PostQuitMessage(0);
        if (gP.img) { GdipDisposeImage(gP.img); gP.img = 0; }
        return 0;
    }
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
    long nRet = 0;
    HWND hWnd = 0, hParent = 0;
    long nSpeedDelay = 0;
    MSG msg = { 0 };
    WNDCLASSEX wcx = { 0 };
    WCHAR szClassName[] = L"ZSPIN_LAYERED";
    WCHAR szFileName[MAX_PATH] = { 0 };

    wcx.cbSize = sizeof(wcx);
    long IsInitialized = GetClassInfoEx(hInstance, szClassName, &wcx);
    if (IsInitialized == 0) {
        wcx.style = CS_HREDRAW | CS_VREDRAW;
        wcx.lpfnWndProc = &SpinnerProc;
        wcx.cbClsExtra = 0;
        wcx.cbWndExtra = 0;
        wcx.hInstance = hInstance;
        wcx.hIcon = NULL;
        wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = NULL;
        wcx.lpszMenuName = NULL;
        wcx.lpszClassName = szClassName;
        wcx.hIconSm = wcx.hIcon;
        if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
    }

    if (IsInitialized) {
        hWnd = CreateWindowEx(WS_EX_TOOLWINDOW | WS_EX_TOPMOST | WS_EX_LAYERED, szClassName, szClassName, WS_POPUP | WS_VISIBLE,
            0, 0, 0, 0, NULL, (HMENU)NULL, hInstance, NULL);
        if (hWnd) {

            LONG_PTR hGDIplus = 0;
            RtlMoveMemory(&szFileName, lpCmdLine, sizeof(szFileName));
            if (FileExist(szFileName)) {
                hGDIplus = GdipStart(); if (hGDIplus) { SpinnerInit(hParent, hWnd, szFileName, nSpeedDelay); }
            }
            if (hGDIplus == 0) { DestroyWindow(hWnd); }

            UpdateWindow(hWnd);

            while (GetMessage(&msg, NULL, 0, 0)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            if (hGDIplus) { GdipEnd(hGDIplus); }
            nRet = (long)msg.wParam;
        }
    }
    return nRet;
}
